<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2005 Olivier Meunier. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

// Plugins root
define('DC_PLUGINS_ROOT','/usr/share/dotclear/plugins');

// Template cache directory
define('DC_TPL_CACHE','/var/cache/dotclear/cache');

include('/var/lib/dotclear/master_key.inc.php');

// Crypt key (password storage)
define('DC_MASTER_KEY',$dc_master_key);
unset($dc_master_key);

$DC_ADMIN_URL='';
$DC_SESSION_NAME='dcxd';
$DC_DBPREFIX='dc_';
include('/etc/dotclear/dbconfig.php');
include('/etc/dotclear/config.php');

if (isset($not_yet_configured) and $not_yet_configured) {
	echo "<p>You must configure dotclear in /etc/dotclear/config.php";
	echo "<p>and then go to <a href=\"$DC_ADMIN_URL/install\">$DC_ADMIN_URL/install</a>";
	exit(1);
}

// Database driver (mysql, pgsql, sqlite)
define('DC_DBDRIVER',$dbtype);

// Database hostname (usually "localhost")
define('DC_DBHOST',$dbserver);

// Database user
define('DC_DBUSER',$dbuser);

// Database password
define('DC_DBPASSWORD',$dbpass);

if ($dbtype == 'sqlite' && $basepath != '') {
	$dbname="$basepath/$dbname";
}
// Database name
define('DC_DBNAME',$dbname);

// Tables' prefix
define('DC_DBPREFIX',$DC_DBPREFIX);

// Admin URL. You need to set it for some features.
define('DC_ADMIN_URL',$DC_ADMIN_URL);

// Cookie's name
define('DC_SESSION_NAME',$DC_SESSION_NAME);

unset($DC_DBPREFIX);
unset($DC_ADMIN_URL);
unset($DC_SESSION_NAME);
unset($dbtype);
unset($dbserver);
unset($dbuser);
unset($dbpass);
unset($dbname);
unset($basepath);

?>
